/***************************************
 *
 *   kstat_chain.c - Ausgabe der
 *   verketteten Liste der kstats
 *
 *   gcc -Wall -o kstat_chain kstat_chain.c -lkstat
 *
 ***************************************/

#include <stdio.h>
#include <kstat.h>

int main()
{
    kstat_ctl_t *kc;
    kstat_t     *kp;
    char*       types[] = {"raw", "named", "intr", "io", "timer"};

    /* kstat ffnen */
    kc = kstat_open();
    if (0 == kc) {   
        fprintf(stderr, "Kann kstat nicht ffnen.\n");
        return -1;
    }

    /* Liste durchlaufen */
    printf("%-25s %-5s %s.%s\n", "Name", "Typ", "Modul", "Inst");

    for (kp=kc->kc_chain; kp; kp=kp->ks_next)
        printf( "%-25s %-5s %s.%d\n",
                kp->ks_name,
                types[kp->ks_type],
                kp->ks_module,
                kp->ks_instance
              );

    /* kstat schlieen */
    kstat_close(kc);

    return 0;
}
