#!/usr/local/bin/perl


use strict;
use CGI qw(:standard -no_xhtml);
use Solaris::Kstat;
use Sys::Hostname;


# -----  kstat Daten erzeugen  -----
#
my $kstat = new Solaris::Kstat();

my ($data1, $ticks1) = getCPUData($kstat);
sleep 2;
$kstat->update();
my ($data2, $ticks2) = getCPUData($kstat);

my $tickDiff = $ticks2 - $ticks1;
my $results;

for my $cpu (keys %$data1)
{   next unless $data2->{$cpu};

    for my $status (qw(idle user kernel wait))
    {   $results->{$cpu}->{$status} = ( $data2->{$cpu}->{$status} -
                                        $data1->{$cpu}->{$status}
                                      ) / $tickDiff;
    }
}


# -----  HTML generieren  -----
#
my $q = new CGI();

my $scale    = 400; # Skalierungsfaktor fr Anzeige
my $imgPath  = "."; # Pfad zu GIFs

my $hostName = Sys::Hostname::hostname();

print
  $q->header(),
  $q->start_html(-title => "CPU-Aktivitt"),
  $q->h2({align => "center"}, "CPU-Aktivit&auml;t auf $hostName" ),
  $q->p( $q->hr({size => 1, width => "80%"}) ),

$q->table
( { border =>  3,       cellspacing => 0,
    align  => "center", cellpadding => 20,
  },
  map $q->Tr(
      $q->td( [ "CPU$_",
      $q->table
      ( { border => 0, cellspacing => 6 },
        $q->Tr
        ( [ map $q->td( [ $_->[0],
                          sprintf("%.2f %%", 100*$_->[1]),
                          $q->img( { src    => "$imgPath/$_->[2]",
                                     height => 3,
                                     width  => int $scale * $_->[1]
                                 } )
                      ] )
            => ( ["Gesamt", 1-$results->{$_}->{idle}, "black1px.gif"],
                 ["Kernel", $results->{$_}->{kernel}, "red1px.gif"  ],
                 ["User",   $results->{$_}->{user},   "bl1px.gif" ],
                 ["Wait",   $results->{$_}->{wait},   "green1px.gif"]
               )
        ] )
      )
      ] ) )
  => sort {$a <=> $b} keys %$results
),

$q->p( $q->hr({size => 1, width => "80%"}) ),
$q->end_html();


# -----  getCPUData()  ------
#
sub getCPUData
{   my $kstat = shift;

    my @onlineCPUs =
        grep $kstat->{cpu_info}->{$_}->{"cpu_info$_"}->{state} eq "on-line"
        => keys %{ $kstat->{cpu_info} };

    my @stati = qw(idle user kernel wait);

    my $cpuData;
    @{ $cpuData->{$_} }{@stati} =
    @{ $kstat->{cpu_stat}->{$_}->{"cpu_stat$_"} }{@stati}
        for @onlineCPUs;

    return ($cpuData, $kstat->{unix}->{0}->{system_misc}->{clk_intr});
}
