#!/usr/local/bin/perl

use POSIX;
use Solaris::Kstat;


# -----  Uptime bestimmen  -----
#
my $ticks = Solaris::Kstat->new->{unix}->{0}->{system_misc}->{clk_intr};
my $secs  = $ticks / sysconf _SC_CLK_TCK;


# -----  Zeit berechnen  -----
#
my $dd = int $secs/86400;   $secs -= $dd * 86400;
my $hh = int $secs/3600;    $secs -= $hh * 3600;
my $mm = int $secs/60;      $secs -= $mm * 60;
my $ss = $secs;

printf "Uptime: %d Tag(e), %d Stunde(n), %d Minute(n), %d Sekunde(n)\n",
       $dd, $hh, $mm, $ss;
