/***************************************
 *
 *   kstat_uptime.c - Ausgabe der
 *   uptime
 *
 *   gcc -Wall -o kstat_uptime kstat_uptime.c -lkstat
 *
 ***************************************/

#include <stdio.h>
#include <kstat.h>
#include <unistd.h>
#include <sys/param.h>

int main()
{
    kstat_ctl_t   *kc;
    kstat_t       *kp;
    kstat_named_t *kn;

    long          hz;
    long          secs;

    int           dd;
    int           hh;
    int           mm;
    int           ss;

    hz = sysconf(_SC_CLK_TCK);

    /* kstat ffnen */
    kc = kstat_open();
    if (0 == kc)
    {   fprintf(stderr, "Kann kstat nicht ffnen.\n");
        return -1;
    }

    /* uptime Zhler auslesen */
    kp = kstat_lookup(kc, "unix", 0, "system_misc");
    if (0 == kp)
    {   fprintf(stderr, "Kann system_misc nicht finden.\n");
        return -1;
    }
    if(-1 == kstat_read(kc, kp, 0))
    {   fprintf(stderr, "Kann kstat nicht lesen.\n");
        return -1;
    }
    kn = (kstat_named_t*)kstat_data_lookup(kp, "clk_intr");
    secs = kn->value.ul / hz;

    /* Zeit berechnen */
    dd = secs/86400;    secs -= dd * 86400;
    hh = secs/3600;     secs -= hh * 3600;
    mm = secs/60;       secs -= mm * 60;
    ss = secs;

    printf( "Uptime: %d Tag(e), %d Stunde(n), %d Minute(n), %d Sekunde(n)\n",
            dd, hh, mm, ss
          );

    /* kstat schlieen */
    kstat_close(kc);

    return 0;
}
